import java.util.List;

/**
 * @author Erwan LBP
 * @version 1.0
 * @since 21-02-2017
 */
public class NordOuest {

    private int[][] tab_result;
    private List<List<Integer>> tabDeb;
    private int nbL, nbC;
    private int[] demandes;
    private int[] stocks;
    private int sommeSD;

    public NordOuest(List<List<Integer>> tabDeb) {
        this.tabDeb = tabDeb;
        this.nbL = tabDeb.size() - 1;
        this.nbC = tabDeb.get(0).size() - 1;
        this.tab_result = new int[nbL][nbC];
        for (int i = 0; i < nbL; i++)
            for (int j = 0; j < nbC; j++)
                tab_result[i][j] = 0;

        sommeSD = tabDeb.get(nbL).get(nbC);
        this.stocks = new int[nbC];
        for (int i = 0; i < nbC; i++)
            stocks[i] = tabDeb.get(nbL).get(i);
        this.demandes = new int[nbL];
        for (int i = 0; i < nbL; i++)
            demandes[i] = tabDeb.get(i).get(nbC);
    }

    public boolean run() {
        int i = 0, j = 0;
        while (i < nbC && j < nbL) {
            tab_result[j][i] = Integer.min(stocks[i], demandes[j]);
            stocks[i] -= tab_result[j][i];
            demandes[j] -= tab_result[j][i];
            if (stocks[i] == 0) i++;
            if (demandes[j] == 0) j++;
        }
        return true;
    }

    @Override
    public String toString() {
        String s = "========================================\n";
        for (int i = 0; i < nbL; i++) {
            for (int j = 0; j < nbC; j++) {
                s += tab_result[i][j] + "\t";
            }
            s += demandes[i] + "\n";
        }
        for (int i = 0; i < nbC; i++) {
            s += stocks[i] + "\t";
        }
        s += sommeSD;
        return s;
    }

    public int coutMaximum() {
        int somme = 0;
        for (int i = 0; i < nbL; i++) {
            for (int j = 0; j < nbC; j++) {
                somme += tabDeb.get(i).get(j) * tab_result[i][j];
            }
        }
        return somme;
    }
}
