import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Erwan LBP
 * @version 2.0
 * @since 21-02-2017
 */
public class Parser {
    public static boolean parse(String fileToParse, String splitBy, List<List<Integer>> list_result) {
        System.out.println("Debut du parse");
        long timeDeb = System.currentTimeMillis();
        String line;
        int cpt = 0;
        try (BufferedReader br = Files.newBufferedReader(Paths.get(fileToParse), Charset.forName("ISO-8859-1"))) {
            while ((line = br.readLine()) != null) {
                String[] lineSplitted = line.split(splitBy);
                if (lineSplitted.length > 1 && lineSplitted[0].charAt(0) != '#') {
                    List<Integer> lineInt = new ArrayList<>();
                    for (String s : lineSplitted) {
                        try {
                            int n = Integer.parseInt(s);
                            lineInt.add(n);
                        } catch (Exception e) {
                            System.out.println("La ligne " + s + " n'est pas un entier !");
                        }
                    }
                    list_result.add(lineInt);
                    cpt++;
                }
            }
            System.out.println("Lecture du fichier reussie, " + cpt + " lignes lues");
        } catch (FileNotFoundException fnfe) {
            System.out.println("[X]\tLe fichier a lire est introuvable");
            return false;
        } catch (IOException ioe) {
            ioe.printStackTrace();
            System.out.println("[X]\tErreur lors de la lecture du fichier");
            return false;
        }

        System.out.println("Fin du parse, durée : " + (System.currentTimeMillis() - timeDeb) + "ms\n");
        return true;
    }
}
