#!/usr/bin/env python
# coding=utf-8

import sys
import array
import matplotlib.pyplot as plt

""" NORD OUEST """

def display(tab):
    for a in tab:
        print("|",)
        for b in a:
            if (len(str(b)) == 1):
                print(" " + str(b) + " |",)
            else:
                print(" " + str(b) + "|",)
        print()
        
def calculCout(tab, tab2):
    res = 0
    for i in range(0, len(tab)-1):
        for j in range(0, len(tab[0])-1):
           res += (tab[i][j]*tab2[i][j])

    return res
            
#Fonction principale
def nordOuest(tab):
    print()
    tab2 = [[0 for a in range(len(tab[0]))] for i in range(len(tab))]
    i = 0
    j = 0

    #A chaque itération, on enlève le minimum des offres et demandes dans la case et on décale sur la droite ou en bas
    while ((i != len(tab) - 1) & (j != len(tab[0]) - 1)):
        temp = min(tab[i][len(tab[i]) - 1], tab[len(tab) - 1][j])
        tab[len(tab) - 1][j] -= temp
        tab[i][len(tab[i]) - 1] -= temp
        tab[len(tab) - 1][len(tab[0]) - 1] -= temp
        tab2[i][j] = temp

        if (tab[len(tab) - 1][j] == 0):
            j+=1
        elif (tab[i][len(tab[i]) - 1] == 0):
            i+=1

    display(tab2)
    
    print("Cout: " + str(calculCout(tab, tab2)))
    return calculCout(tab, tab2)
    
""" ---------------------------------------------------------------- """

""" BALAS-HAMMER """

case_nulle = 999999

# fonction d'affichage d'une matrice (tableau 2D)
def afficher_tab(t):
    for i in t:
        print ("| ",)
        for j in i:
            if (j == case_nulle):
                x = "x"
            else:
                x = j
            l = len(str(j))
            if (l == 1):
                print(x, " | ",)
            if (l == 2):
                print(x, "| ",)
            if (l > 2):
                print(x, " | ",)
        print()

# fonction de detection de fin d'algo
def fin_algo(t):
    for i in t:
        for j in i:
            if (j != case_nulle):
                return False
    return True

# Fonction de verification : 1 seul element dans la matrice (vrai ou faux)
def last_elem(t):
    nb_elem = 0
    for i in t:
        for j in i:
            if (j!=case_nulle):
                nb_elem += 1
    if (nb_elem > 1):
        return False
    else:
        return True

# fonction de recuperation du min dans un tableau 1D (indice)
def recup_min(t):
    return t.index(min(t))

# fonction de recuperation du second min dans un tableau 1D (indice)
def recup_min2(t):
    i = t.index(min(t))
    tmp = []
    for j in range(len(t)):
        if (j != i):
            tmp.append(t[j])
        else:
            tmp.append(case_nulle)
    return tmp.index(min(tmp))

# fonction de calcul de regret pour 1 ligne
def regret(l):
    m1 = recup_min(l)
    m2 = recup_min2(l)
    if (l[m2] == case_nulle):
        return 0
    else:
        return l[m2] - l[m1]

# fonction de recuperation de ligne/colonne avec regret max : ('type', indice)
def regret_max(t):
    # calcul index regret max ligne
    max_ligne = 0
    #while (t[max_ligne] == case_nulle):
    #       max_ligne += 1
    for i in t:
        for j in i:
            if (j != case_nulle):
                if (regret(i) > regret(t[max_ligne])):
                    max_ligne = t.index(i)
    # calcul index regret max colonne
    tmp = list(zip(*t))
    max_colonne = 0
    #while (tmp[max_colonne] == case_nulle):
    #    max_colonne += 1
    for i in tmp:
        for j in i:
            if (j != case_nulle):
                if (regret(i) > regret(tmp[max_colonne])):
                    max_colonne = tmp.index(i)
    # calcul du max des deux
    if (regret(t[max_ligne]) > regret(tmp[max_colonne])):
        return ("Ligne", max_ligne)
    else:
        return ("Colonne", max_colonne)

# fonction de suppression des lignes/colonnes où l'offre/la demande est comblée
def suppressions(t1, t2, i, k, mini):
    # Cas offre = regret min
    if (T_offre[i] == mini):
        # suppression de la ligne
        for j in range(0, len(t1[i])):
            t1[i][j] = case_nulle
        # on verifie la somme des couts sur la colonne dans le 2e tableau :
        # si egal a la demande => suppression de la colonne
        somme_colonne = 0
        for j in t2:
            somme_colonne += j[k]
        if (somme_colonne == T_demande[k]):
            for j in t1:
                j[k] = case_nulle
    # Cas demande = regret min
    if (T_demande[k] == mini):
        # suppression de la colonne
        for j in t1:
            j[k] = case_nulle
        # on verifie la somme des couts sur la ligne dans le 2e tableau :
        # si egal a l'offre => suppression de la ligne 
        somme_ligne = 0
        for j in t2[i]:
            somme_ligne += j
        if (somme_ligne == T_offre[i]):
            for j in range(0, len(t1[i])):
                t1[i][j] = case_nulle
    
# fonction de maj dans tableau final + suppression ligne/colonne dans tableau initial
def balas_hammer(t1, t2, x):
    # Cas où regret max sur ligne
    if (x[0] == "Ligne"):
        i_min = recup_min(t1[x[1]])
        mini = min(T_offre[x[1]], T_demande[i_min])
        t2[x[1]][i_min] = mini # ajout de la nouvelle valeur dans tableau final
        # Suppression des lignes/colonnes saturées
        suppressions(t1, t2, x[1], i_min, mini)
        # mise a jour offre/demande restante
        T_offre[x[1]] -= mini
        T_demande[i_min] -= mini
    # Cas où regret max sur colonne
    else:
        i_min = recup_min(list(zip(*t1))[x[1]])
        mini = min(T_offre[i_min], T_demande[x[1]])
        t2[i_min][x[1]] = mini # ajout de la nouvelle valeur dans tableau final
        # Suppression des lignes/colonnes saturées
        suppressions(t1, t2, i_min, x[1], mini)
        # mise a jour offre/demande restante
        T_offre[i_min] -= mini
        T_demande[x[1]] -= mini
    # cas particulier : si plus qu'un seul element dans la matrice
    if (last_elem(t1)):
        for i in range(0, len(t1)):
            for j in range(0, len(t1[i])):
                if (t1[i][j] != case_nulle):
                    offre_actuelle = 0
                    for k in t2[i]:
                        if (k != case_nulle):
                            offre_actuelle += k
                    t2[i][j] = T_offre_init[i] - offre_actuelle
                    t1[i][j] = case_nulle
    # Affichage de la matrice
    for i in range (0, len(t1[0])):             
        print("-----",)
    print("-")
    afficher_tab(t1)


         
# PROGRAMME PRINCIPAL

# Lecture des données
lines = [line.rstrip('\n') for line in open('donnees_transport.txt')]

# Initialisation du tableau initial
T1 = [] # solution initiale
for i in range(0, len(lines)):
    x = [int(n) for n in lines[i].split("\t")]
    T1.append(x)

# copie du tableau (donnéees) initial
T1_init = [] 
for i in range(0, len(lines)):
    x = [int(n) for n in lines[i].split("\t")]
    T1_init.append(x)

# Récupération du nombre de lignes/colonnes
l = len(T1)-1 # Nb de ligne
c = len(T1[0])-1 # Nb de colonnes

# Initialisation du tableau final avec des 0
T2 = [[0 for j in range(c)] for i in range(l)]

# On creer 1 tableau pour les offres / 1 tableau pour les demandes
T_demande = T1[-1]
T_offre = []
T_offre_init = []
for i in T1:
    if (i != T1[-1]):
        T_offre.append(i[-1])
        T_offre_init.append(i[-1])
# On retire les offres/demandes de la matrice initiale
T1.pop()
for i in T1:
    i.pop()

# Affichage tableau initial
print("==== Tableau initial ====")
afficher_tab(T1)

# Application de Nord Ouest
print()
print("Nord-Ouest :")
cout_no = nordOuest(T1)

# Application de Balas-Hammer
print()
print("Balas-Hammer :")
while(fin_algo(T1) == False):
    balas_hammer(T1,T2,regret_max(T1))
print()

# Tableau final
print("===== Tableau final =====")
afficher_tab(T2)

# Calcul et affichage du resultat pour balas-hammer
res = 0
for i in range(0, l):
    for j in range(0, c):
        res += (T2[i][j] * T1_init[i][j])
print("Coût : ", res)


# Graphique

D = {u'Nord-Ouest':cout_no, u'Balas-Hammer': res}
plt.bar(range(len(D)), D.values(), align='center')
plt.xticks(range(len(D)), D.keys())
plt.xlabel('')
plt.ylabel('Coût')
plt.title('Comparaison de coût')
plt.show()
