import random
import time
import datetime
import statistics
#Algorithmes de colonies de fourmis

#But : trouver le chemin le plus court de A à B 
#contrainte : Passer par toutes les villes
#-- Partie I --
#Etape 1 : Initialiser 1 fourmi par ville
#Etape 2 : faire visiter toutes les villes (chemin cout + faible)
#=> retenir les chemins empruntés
#Etape 3 : Ajouter +1 à tout les chemins empruntés

#-- Partie II --
#Etape 1 : Initialiser fourmis aléatoirement aux villes
#Etape 2 : faire visiter toutes les villes (chemins les plus empruntés)
#=> Si passages égaux => random
#Etape 3 : Répéter Partie II n fois

def chargement():
    fichier = open("dantzig42_d.txt","r")
    Matrix = []
    count = 0;
    for i in fichier:
        #i.strip()
        ligne = i.split()
        ligne[len(ligne)-1] = ligne[len(ligne)-1].rstrip('\n')
        for j in range(0, len(ligne)):
            ligne[j] = int(ligne[j])

        Matrix.append(ligne)

    fichier.close()
    
    return Matrix

#Initialisation des phéromones à 0
def init_trace(taille):
    tab_trace = []

    for i in range(0,taille):
        ligne = [100]*taille
        tab_trace.append(ligne)
    return tab_trace

def sum_tab(tab):
    total=0
    for i in range(0,len(tab)):
        total += tab[i]
    return total

def evaporation(tab_trace,p):
    for i in range(0,len(tab_trace)):
        for j in range(0,len(tab_trace)):
            if ( j == i):
                (tab_trace[j])[i] = 0
            else:
                (tab_trace[i])[j] = tab_trace[i][j]*(1-p) + 10
                (tab_trace[j])[i] = tab_trace[j][i]*(1-p) + 10
    return tab_trace
    
def renforcement(tab,tab_trace,k):
    for i in range(0,len(tab_trace)):
        for j in range(0,len(tab_trace)):
            if ( j == i):
                (tab_trace[j])[i] = min(tab_trace[j])
            else:
                (tab_trace[i])[j] = (tab_trace[i])[j] + (1/pow((tab[i])[j],k))*pow(10,3*(k+1))
                (tab_trace[j])[i] = (tab_trace[j])[i] + (1/pow((tab[i])[j],k))*pow(10,3*(k+1))

    return tab_trace

def matrice_sup_to_all(tab):
    for i in range(0,len(tab)):
        for j in range(i+1,len(tab)):
            (tab[j])[i] = (tab[i])[j]
    return tab

def get_ville(tab_trace,ville, visited):
    temp_tab_trace = [x for x in tab_trace[ville]]
    for x in range(0,len(visited)):
        if visited[x] == 1:
            temp_tab_trace[x] = 0

    nb_random = int(random.uniform(min(temp_tab_trace), sum(temp_tab_trace)))
    
    for i in range(0,len(temp_tab_trace)):
        nb_random -= temp_tab_trace[i]
        if nb_random < 0:
            return i

    return i

def iteration(tab,tab_trace,ville):
    
    visited = [0] * (len(tab))
    visited[ville] = 1
    next_ville=ville

    for i in range(0,len(tab)-1):
        while(visited[next_ville] == 1):
            next_ville = get_ville(tab_trace,ville, visited)

        (tab_trace[ville])[next_ville] += 100
        (tab_trace[next_ville])[ville] += 100

        ville = next_ville
        visited[ville] = 1

    return tab_trace
    
def cout(tab,tab_trace):
    ligne_du_max = 0
    the_max = 0
    for i in range(0,len(tab)):
        if (max(tab_trace[i])>the_max):
            ligne_du_max = i
            the_max = max(tab_trace[i])

    visited = [0 for i in tab_trace]
    ville = ligne_du_max

    cout = 0
    for i in range(0,len(tab)-1):
        the_max = 0
        indice = 0
        for j in range(0,len(tab)):
            if (ville != j):
                if (the_max<(tab_trace[ville])[j] and visited[j] == 0):

                    the_max = (tab_trace[ville])[j]
                    indice = j

        cout = cout + (tab[ville])[indice]
        ville = indice
        visited[ville] = 1
        
    return cout

def normalisation(tab):
    the_max=0
    for i in range(0,len(tab)):
        if (max(tab[i]) > the_max):
            the_max = max(tab[i])
    for i in range(0,len(tab)):
            for j in range(0,len(tab)):
                (tab[i])[j] = ((tab[i][j])/the_max + 1)*the_max
                (tab[j])[i] = ((tab[j][i])/the_max + 1)*the_max
    return tab
            
def fourmis():
    random.seed(datetime.datetime.now())
    print("-- Debut du programme --\n")
    
    print("** Chargement du fichier **")
    #Chargement du fichier 
    tab = chargement();
    tab = matrice_sup_to_all(tab)

    #Creation des phéromones
    tab_trace = init_trace(len(tab))

    print("Iteration")
    for i in range (0,len(tab)):
        tab_trace = iteration(tab,tab_trace,random.randint(0, len(tab)-1))

    nb_iteration = 100
    for j in range(0,nb_iteration):
        #print(tab_trace)
        print("**Iteration ",j," **")
        tab_trace = iteration(tab,tab_trace, random.randint(0, len(tab)-1))
        print("EVAPORATION")
        tab_trace = evaporation(tab_trace,0.2)
        print("RENFORCEMENT")
        tab_trace = renforcement(tab,tab_trace,j)
        #tab_trace = normalisation(tab_trace)

    print(cout(tab,tab_trace))

fourmis()
